
Redmine - Feature #2679

Ticket grouping

2009-02-05 12:53 - Maxim Krušina

Status: Closed Start date: 2009-02-05

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 0.9.0   

Resolution: Fixed   

Description

It can be very handy to have "Group by" option in issue list view (www.myredmine.com//issues).

In status box, there can be new line under Status: Group by, and there can be select box where you can select column to group by.

Simillar functionality was in Trac (if I remeber well,, uit's long time ;).

For what it should be usefull?

For example: I would like to create special report, where I can see all our developers and how much tickets they have assignet to

them.

It's very handy for moving tickets between users and balancing work.

Anyway, there much more usage for this, like group by version, or group by tracker.

Visualy it can be done by more tables separated, like it is in reporting (plugin?).

What others think?

Related issues:

Related to Redmine - Defect #33290: Unnecessary database access when IssueQue... Closed

Associated revisions

Revision 2696 - 2009-04-26 15:09 - Jean-Philippe Lang

Ticket grouping (#2679).

Revision 2711 - 2009-05-04 20:04 - Jean-Philippe Lang

Adds group folding on issue list (#2679).

Revision 3071 - 2009-11-16 19:07 - Jean-Philippe Lang

Allow issue grouping by custom field (#2679).

History

#1 - 2009-02-10 00:44 - Eric Davis

+1 I'd like to see one level of grouping (e.g. Group issues by Status).  A simple UI that would work is to have a select box with each Filter name and a

none (default).

#2 - 2009-02-10 22:49 - Jens Berlips

+1, I wrote a note about this in: Issue #2481 as well. The grouping in Trac is excellent.

#3 - 2009-02-11 00:31 - Markus Knittig

+1

The Scrumalliance Redmine has a plugin for issue grouping. Not for all attributes, but it's a start...

#4 - 2009-02-11 03:04 - Ewan Makepeace

+1

Could be done as seperate tables per group (though that would be a bit awkward given the Redmine UI style) or using Outlook style grouping bars

(with a + or - to expand or collapse the group). Might not even require a Group By field - often grouping issues by the field in the sorted column is

enough, and that change could perhaps be accomplished in the view alone?
#5 - 2009-02-11 03:04 - Ewan Makepeace

Ewan Makepeace wrote:

+1

Could be done as seperate table per group (though that would be a bit awkward given the Redmine UI style) or using Outlook style grouping

bars (with a + or - to expand or collapse the group). Might not even require a Group By field - often grouping issues by the field in the sorted

column is enough, and that change could perhaps be accomplished in the view alone?

#6 - 2009-02-17 06:17 - Andrew Chaika

- File query_add_group_by_patch.zip added

I have developed issues grouping patch for 0.8.0 version of redmine.

I have tested it and it's worked ok.

Maybe code is not perfect because I'm novice in Ruby and Rails.

PS After patch apply it's need to migrate database (rake db:migrate)

#7 - 2009-03-02 21:22 - Andrew Chaika

- File group_by_patch.patch added

patch

#8 - 2009-04-01 11:15 - Maxim Krušina

Hi, can be this merged into trunk?

I'm not so much big friend of patches, because we're using trunk version by SVN updates.

Thanx!

#9 - 2009-04-02 13:22 - Andrew Chaika

There are such functionality converted to plugin - http://www.redmine.org/boards/3/topics/4701

#10 - 2009-04-09 18:10 - Andrew Chaika

- File redmine_issues_group.zip added

- File issues_grouping_plugin.png added

Issues Group Plugin version 0.0.3:

Features:

Issues/Ticket grouping

Introduced queries categories, and grouping by them in sidebar

Queries in sidebar now shows count of issues in they

Group saving in queries

Recent changes:

more Rubish code

some cleanup

compatibility with saving sort order in queries

group by any available issue field
issues_grouping_plugin.png 

PS I think that this functionality must be in Redmine 0.9.x or 1.0.0

#11 - 2009-04-09 23:06 - Markus Knittig

Good plugin, the only thing that's stopping me from using it in a productive system is that when you already have a bunch of queries the plugin

doesn't seem to work (complains about missing category)...

#12 - 2009-04-10 07:07 - Andrew Chaika

Markus Knittig wrote:

Good plugin, the only thing that's stopping me from using it in a productive system is that when you already have a bunch of queries the plugin

doesn't seem to work (complains about missing category)...
 Maybe you don't run db migration, this plugin needs it (I missing this in description):

rake db:migrate_plugins

 I have tested installation of this plugin on trunk version and it works without any errors

#13 - 2009-04-10 08:16 - Markus Knittig

Hm, this works on my produtive system. Thanks. But it didn't seem to to work with the example data...

#14 - 2009-04-10 16:29 - Andrew Chaika

Markus Knittig wrote:

Hm, this works on my produtive system. Thanks. But it didn't seem to to work with the example data...

 Development, test or demo database migration needed too:

rake db:migrate_plugins RAILS_ENV="development"

#15 - 2009-04-11 01:19 - Mischa The Evil

This plugin at v0.0.3 looks quite neat. As noted by Eric on the referenced forum-thread it overrides some controllers though, but in the new version

this is done pretty smart (which will prevent most of the syncing-problems)... Looks really promising... :thumbsup:

One caveat though: the package contains an error on lines 10 and 11 in the file ../app/views/issues/_sidebar.rhtml. These lines are missing the

controller-part in the links. They should be changed from: 

  planning_links << link_to(l(:label_calendar), :action => 'calendar', :project_id => @project) if User.curren

t.allowed_to?(:view_calendar, @project, :global => true)

  planning_links << link_to(l(:label_gantt), :action => 'gantt', :project_id => @project) if User.current.allo

wed_to?(:view_gantt, @project, :global => true)

to: 

  planning_links << link_to(l(:label_calendar), :controller => 'issues', :action => 'calendar', :project_id =>

 @project) if User.current.allowed_to?(:view_calendar, @project, :global => true)

  planning_links << link_to(l(:label_gantt), :controller => 'issues', :action => 'gantt', :project_id => @proj

ect) if User.current.allowed_to?(:view_gantt, @project, :global => true)

#16 - 2009-04-12 15:35 - Andrew Chaika

- File redmine_issues_group_0_0_4.zip added

Version 0.0.4:

Added french language

Corrected links in sidebar

#17 - 2009-04-12 15:54 - Markus Knittig

Good work. Have you considered to publish your plugin on GitHub (where most of the Redmine plugins are hosted)? That would make it easier to

contribute and kepping the plugin up to date...

#18 - 2009-04-12 19:49 - Andrew Chaika

Markus Knittig wrote:

Good work. Have you considered to publish your plugin on GitHub (where most of the Redmine plugins are hosted)? That would make it easier

to contribute and kepping the plugin up to date...

 I wish that functionality of this plugin be included in trunk version, because it can't be implemented separately from Redmine core like other plugins.

There is some overridings, which can break plugin in future if core changed.

About plugins and github - I use local svn and don't know git yet, I think that we need to make community for plugin/patches developers with svn/git,

Redmine tracker, maybe this can be redminehacks.org

#19 - 2009-04-12 20:40 - Markus Knittig

Andrew Chaika wrote:
I wish that functionality of this plugin be included in trunk version, because it can't be implemented separately from Redmine core like other

plugins.

 Then you should include some tests. Also, I'm not sure about the category feature. In principal It's useful, but I kinda don't like that it's working with

free text. Although a own entity might be overkill. A compromise could be some sort of auto completion...

About plugins and github - I use local svn and don't know git yet, I think that we need to make community for plugin/patches developers with

svn/git, Redmine tracker, maybe this can be redminehacks.org

 I'm sure Eric will take good care of redminehacks.org (which used git and will probably continue to do so)...

#20 - 2009-04-15 13:56 - Maxim Krušina

Thanx a lot for such a great plugin!

Is there some project page of this plugin?

I would like to close this issue and discuss it probably somewhere more dedicated ;)

#21 - 2009-04-20 14:47 - Andrew Chaika

Maxim Krušina wrote:

Thanx a lot for such a great plugin!

Is there some project page of this plugin?

I would like to close this issue and discuss it probably somewhere more dedicated ;)

 For now only forum thread - http://www.redmine.org/boards/3/topics/4701

I have published version 0.0.5 there

I try to use Git for Windows to upload plugin code to https://github.com, but it's unsuccessful yet

#22 - 2009-04-20 16:27 - Markus Knittig

Cool that you final decided to use git. You won't regret it, it's really great... :)

Do you have problems with git on Windows or with GitHub? Because GitHub is IMO really easy to use. Don't know about git on Windows though.

That could be tricky. AFAIK msysGit is the best choice under Windows.

#23 - 2009-04-26 15:03 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version set to 0.9.0

- Resolution set to Fixed

Feature added in r2696.

#24 - 2009-04-26 22:47 - Mischa The Evil

Jean-Philippe Lang wrote:

Feature added in r2696.

 Really great to see this being merged into the trunk... Just a question:

Would it be also possible to add:

the group-folding feature (JS)?

the queries categories, and grouping by them in sidebar?

the queries in sidebar shows count of issues in them?

If you are willing to take these things into the core trunk also, the plugin by Andre Chaika can be considered as a solution for issue #2679 for the

0.8-branch while it's implemented in the core for the trunk...

What do you think?

#25 - 2009-05-04 19:59 - Jean-Philippe Lang

Mischa The Evil wrote:

Would it be also possible to add:

the group-folding feature (JS)?
 Done in r2711.

the queries categories, and grouping by them in sidebar?

 This would be nice, although it's not part of the ticket grouping feature.

the queries in sidebar shows count of issues in them?

 This can really slow things down depending of the number of queries. So I don't think it will be added to the core.

#26 - 2009-05-04 21:31 - Gregor Bader

Great that this is implemented!

Perhaps the feature to display ticket associations (parent -> child) like

http://www.redmine.org/boards/3/topics/4701 as Andrew Chaika suggested could be implemented?

This would be really helpful to manage complex implementations or e.g. a feature request which should be implemented in several sub projects.

Or some other way to display such connections would be good.

#27 - 2009-05-05 01:21 - Mischa The Evil

Jean-Philippe Lang wrote:

Mischa The Evil wrote:

Would it be also possible to add:

the group-folding feature (JS)?

 Done in r2711.

 Great... This "sort of" completes the implementation of the ticket-grouping feature in my opinion... Thanks...

Jean-Philippe Lang wrote:

Mischa The Evil wrote:

the queries categories, and grouping by them in sidebar?

 This would be nice, although it's not part of the ticket grouping feature.

 True that it's not part of the grouping feature. I'll open a new issue regarding this new feature. If I find the time for it I'll try to look to extract the feature

from Andrew's plugin into a new plugin.

Though I believe that (mainly) the UI of the custom filter feature should be optimized (speaking for example of issues #2883, #2002, #3180 and more

generally issue #1307) before/during addition of new (UI) sub-features of the custom filter feature in general.

Jean-Philippe Lang wrote:

Mischa The Evil wrote:

the queries in sidebar shows count of issues in them?

 This can really slow things down depending of the number of queries. So I don't think it will be added to the core.

 Good point which I haven't though of before... ;)

With kind regards,

Mischa.

#28 - 2009-05-05 01:38 - Mischa The Evil

Gregor Bader wrote:

Perhaps the feature to display ticket associations (parent -> child) like
http://www.redmine.org/boards/3/topics/4701 as Andrew Chaika suggested could be implemented?

 I am not sure if Andrew's solution for sub-issues (as he has implemented it in the ticket-grouping plugin v0.0.7) is sufficient enough to get

implemented in the core.

I am certainly not skilled enough to decide (not even to discuss this:), but looking at the comments on issue #443 a sub-issue feature would require a

big overhaul of the core's design...

Jean-Philippe once commented that sub-issues wasn't planned (2 months ago) after more people started implementing the feature as a plugin. I don't

know if the implementation by Andrew is "sufficient" enough to get implemented into the core neither if Jean-Philippe has the opinion that the feature 

must get implemented through a plugin or not...

Regards,

Mischa.

#29 - 2009-05-05 06:18 - Andrew Chaika

Mischa The Evil wrote:

Gregor Bader wrote:

Perhaps the feature to display ticket associations (parent -> child) like

http://www.redmine.org/boards/3/topics/4701 as Andrew Chaika suggested could be implemented?

 I am not sure if Andrew's solution for sub-issues (as he has implemented it in the ticket-grouping plugin v0.0.7) is sufficient enough to get

implemented in the core.

 My implementation is not optimal and I know this, there are lot of subqueries and template recursion in it (one of the solutions is to render subisues

only when user expand parent issue through ajax call).

But it works for me and solve my problem. I will try to make it better if I find the means of doing it.

#30 - 2009-05-05 07:30 - Gregor Bader

Mischa The Evil wrote:

Gregor Bader wrote:

Perhaps the feature to display ticket associations (parent -> child) like

http://www.redmine.org/boards/3/topics/4701 as Andrew Chaika suggested could be implemented?

 I am not sure if Andrew's solution for sub-issues (as he has implemented it in the ticket-grouping plugin v0.0.7) is sufficient enough to get

implemented in the core.

I am certainly not skilled enough to decide (not even to discuss this:), but looking at the comments on issue #443 a sub-issue feature would

require a big overhaul of the core's design...

Jean-Philippe once commented that sub-issues wasn't planned (2 months ago) after more people started implementing the feature as a plugin. I

don't know if the implementation by Andrew is "sufficient" enough to get implemented into the core neither if Jean-Philippe has the opinion that

the feature must get implemented through a plugin or not...

Regards,

Mischa.

 A new or changed implementation of Subissues isn't needed. Everything that's needed is already there. I mean the blocking association between

issues.

This should be possible to display in a tree view as the plugin from Chaika. It's kinda grouping by blocked issues.

#31 - 2009-05-05 08:33 - Andrew Chaika

Gregor Bader wrote:

A new or changed implementation of Subissues isn't needed. Everything that's needed is already there. I mean the blocking association between

issues.

This should be possible to display in a tree view as the plugin from Chaika. It's kinda grouping by blocked issues.

 In one of posts Jean-Philippe wrote that issues relations is not designed to implement subissues feature and it's need to use "some kind of nested

set" for it.

Grouping by blocked issue with one nesting level is easy to implement (add group field - blocking issue) with current issues grouping feature.

#32 - 2009-05-05 14:48 - loic Le Gallou
Great to see this feature integrated in the trunk ! One gap: in the plugin version, it was possible to group issues by custom field, in the trunk version (

r2711) custom fields don't appear in the "group results by" drop down list ...

#33 - 2009-05-17 22:37 - Mischa The Evil

loic Le Gallou wrote:

One gap: in the plugin version, it was possible to group issues by custom field, in the trunk version (r2711) custom fields don't appear in the

"group results by" drop down list ...

 Can you check it with the current trunk and with the info provided in the journals of issue #3321? I guess that if the issue custom field is displayed in

the selected issuelist view then it shows up in the "group by"-options too... I am not sure atm, I'll test it soon too...

Regards,

Mischa.

#34 - 2009-06-29 18:41 - loic Le Gallou

- Status changed from Closed to Reopened

I've tested again with revision r2796, the problem is still there : custom field are in the "filter" list but not in the "group by list". I re-open that task.

#35 - 2009-09-21 11:32 - Chris McKee

+1 Would be good to see this in 0.9

#36 - 2009-09-24 13:09 - doha rouas

hi all,

i have just integrated this plugin and it works fine ... great job!!!

however, i would like to organize my tickets.. i want to create subtickets for each one... i have so many tickets opened and i would like to move them

as subtickets for others.

how can i do that? is there any plugin for that?

thanks in advance for your help

#37 - 2009-10-24 20:11 - Will Bike

+1 for custom fields.  I have also tested on the latest trunk r2967 and find that custom fields are not available to group by even though they are

displayed in the issues list table and are available to filter by.  This would be very useful for our instance of Redmine.  Thanks,

Will

#38 - 2009-11-16 19:02 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Grouping by custom fields added in r3071.

#39 - 2010-09-20 11:01 - goldleaf asd

SPAM

#40 - 2020-04-15 10:59 - Go MAEDA

- Related to Defect #33290: Unnecessary database access when IssueQuery class is defined added

Files

query_add_group_by_patch.zip 16.9 KB 2009-02-17 Andrew Chaika

group_by_patch.patch 5.93 KB 2009-03-02 Andrew Chaika

redmine_issues_group.zip 11.4 KB 2009-04-09 Andrew Chaika

issues_grouping_plugin.png 59.5 KB 2009-04-09 Andrew Chaika

redmine_issues_group_0_0_4.zip 12.3 KB 2009-04-12 Andrew Chaika
